From eea7b8a7c74b372e169af007e1b27e46027ff634 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 03 2017 17:29:14 +0000
Subject: [PATCH 773/1001] Split out the Feed widget to make it more independant


This allows more React-based widgets to coexist without bundling the
React libraries twice.

---

diff --git a/hubs/static/client/app/__tests__/Feed.test.js b/hubs/static/client/app/__tests__/Feed.test.js
index ae93f29..76daf32 100644
--- a/hubs/static/client/app/__tests__/Feed.test.js
+++ b/hubs/static/client/app/__tests__/Feed.test.js
@@ -1,11 +1,11 @@
 /* eslint-env jasmine, jest */
 
-jest.unmock('../components/Feed.jsx');
+jest.unmock('../widgets/feed/Feed.jsx');
 
 import React from 'react';
 import TestUtils from 'react-addons-test-utils';
 
-import Feed from '../components/Feed.jsx';
+import Feed from '../widgets/feed/Feed.jsx';
 
 describe('Feed', () => {
   const matches = [{
diff --git a/hubs/static/client/app/widgets/feed/Feed.jsx b/hubs/static/client/app/widgets/feed/Feed.jsx
new file mode 100644
index 0000000..beec5f7
--- /dev/null
+++ b/hubs/static/client/app/widgets/feed/Feed.jsx
@@ -0,0 +1,53 @@
+import React from 'react';
+import Panel from '../../components/Panel.jsx';
+
+
+class Feed extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      matches: this.props.matches,
+      messageLimit: this.props.options.messageLimit,
+      sse: true,
+    };
+    // If it wasn't instantiated with a url or an error happened, bail
+    if (!this.props.url || !this.state.sse) {
+      return;
+    }
+    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : null;
+    if (!this.source) {
+      return;
+    }
+    this.source.addEventListener('error', () => {
+      this.state.sse = false;
+    }, false);
+    window.onbeforeunload = () => {
+      this.source.close();
+    };
+    this.source.onmessage = resp => {
+      const data = JSON.parse(resp.data);
+      if (this.state.matches.length >= this.state.messageLimit) {
+        this.state.matches.pop();
+      }
+      this.state.matches.unshift(data);
+      this.setState({ matches: this.state.matches });
+    };
+  }
+
+  render() {
+    const feedNodes = this.state.matches.map((match, idx) => {
+      return <Panel match={match} options={this.props.options || {}} key={idx} />;
+    });
+    return (
+      <div>
+        {feedNodes}
+      </div>
+    );
+  }
+
+}
+
+// Don't use the ES6 "export default" construct:
+// http://stackoverflow.com/questions/40294870/module-exports-vs-export-default-in-node-js-and-es6
+module.exports = Feed
diff --git a/hubs/static/client/webpack.config.js b/hubs/static/client/webpack.config.js
index 065ce2f..f97606a 100644
--- a/hubs/static/client/webpack.config.js
+++ b/hubs/static/client/webpack.config.js
@@ -3,16 +3,22 @@ const path = require('path');
 
 const PATHS = {
     app: path.join(__dirname, 'app'),
-    build: path.join(__dirname, '../js')
+    build: path.join(__dirname, '..', 'js', 'build')
 };
 
 const config = {
     entry: {
-        app: path.join(PATHS.app, 'index.jsx')
+        Feed: path.join(PATHS.app, 'widgets', 'feed', 'Feed.jsx'),
     },
     output: {
         path: PATHS.build,
-        filename: 'hubs.js'
+        filename: '[name].js',
+        library: '[name]',
+    },
+    externals: {
+        'jquery': 'jQuery',
+        'react': 'React',
+        'react-dom': 'ReactDOM',
     },
     module : {
         loaders : [{
@@ -21,7 +27,8 @@ const config = {
             exclude: /(node_modules|bowercomponents)/,
             include : PATHS.app
         }]
-    }
+    },
+    plugins: [ new webpack.optimize.CommonsChunkPlugin("common.js") ]
 };
 
 module.exports = config;
diff --git a/hubs/static/js/build/.gitignore b/hubs/static/js/build/.gitignore
new file mode 100644
index 0000000..a6c7c28
--- /dev/null
+++ b/hubs/static/js/build/.gitignore
@@ -0,0 +1 @@
+*.js
